<?php
/*
******************************************************************************************************
INSTRUCTIONS
- Type the feed's file name inside the quotes below (should be 'news.xml').
  This will overwrite the current contents of that file.
*/
$_feed_file = "FILENAME_HERE.xml";
/*
- Place this 'news_get.php' file inside the news folder.
- Run this file. The feed should then be updated automatically.
******************************************************************************************************
*/

$phpbb_root_path = '../forum/';
define ('IN_PHPBB', true);

if (!file_exists($phpbb_root_path . 'extension.inc'))
{
    //die ('<tt><b>phpBB Fetch All:</b>
    //      $phpbb_root_path is wrong and does not point to your forum.</tt>');
}

include_once ($phpbb_root_path . 'extension.inc');
include_once ($phpbb_root_path . 'common.' . $phpEx);
include_once ($phpbb_root_path . 'includes/bbcode.' . $phpEx);
include_once ($phpbb_root_path . 'mods/phpbb_fetch_all/common.' . $phpEx);
include_once ($phpbb_root_path . 'mods/phpbb_fetch_all/posts.' . $phpEx);

$userdata = session_pagestart($user_ip, PAGE_INDEX, $session_length);
init_userprefs($userdata);

if (isset($HTTP_GET_VARS['start']) or isset($HTTP_POST_VARS['start'])) {
    $CFG['posts_span_pages_offset'] = isset($HTTP_GET_VARS['start']) ? $HTTP_GET_VARS['start'] : $HTTP_POST_VARS['start'];
}

// fetch postings
$CFG['date_format'] = 'D, d M Y';
$CFG['time_format'] = 'H:i:s';
$CFG['posts_limit']             = 1;
$CFG['posts_trim_topic_number'] = 0;
$changedate        = phpbb_fetch_posts(2, FETCH_MODE_FIRST);

// fetch postings
$CFG['date_format'] = 'D, d M Y';
$CFG['time_format'] = 'H:i:s';
$CFG['posts_limit']             = 12;
$CFG['posts_trim_topic_number'] = 0;
$news        = phpbb_fetch_posts(2, FETCH_MODE_FIRST);

phpbb_disconnect();

// declare variables for tag and char replacement
$takeouts = array(
    'class="postlink"',
    'class="postbody"',
    'class="genmed"',
    'class="quote"',
    '<br /><br />');

$specials = array(
    '&' => '&amp;',
    '<' => '&lt;',
    '>' => '&gt;',
    '' => '\'',
    '"' => '&quot;',
    '' => '',
    '' => '\'',
    '' => '',
    '' => '&quot;',
    '' => '&quot;',
    './forum' => 'http://www.theghz.com/forum');

$_rss_content = '<?xml version="1.0"?>';
$_rss_content.= '<rss version="2.0">';
$_rss_content.= '<channel>';
$_rss_content.= '<title>The GHZ Newsboard</title>';
$_rss_content.= '<link>http://www.theghz.com/news</link>';
$_rss_content.= '<description>The GHZ - Newsboard Updates</description>';
$_rss_content.= '<language>en</language>';
$_rss_content.= '<copyright>Copyright 1997-2006, Jared Matte</copyright>';
$_rss_content.= '<lastBuildDate>';

for ($i = 0; $i < count($changedate); $i++)
{
	$_rss_content.= $changedate[$i]['date'];
	$_rss_content.= $changedate[$i]['time'];
	$_rss_content.= 'EST';
}

$_rss_content.= '</lastBuildDate>';
$_rss_content.= '<generator>phpBB FetchAll</generator>';
$_rss_content.= '<category>Sonic the Hedgehog</category>';
$_rss_content.= '<webMaster>segaholic2@theghz.com</webMaster>';
$_rss_content.= '<ttl>60</ttl>';
$_rss_content.= '<image>';
$_rss_content.= '<title>[Validate This RSS Feed]</title>';
$_rss_content.= '<url>http://www.theghz.com/valid-rss.png</url>';
$_rss_content.= '<link>http://feedvalidator.org/check?url=http://www.theghz.com/rss.xml</link>';
$_rss_content.= '<width>119</width>';
$_rss_content.= '<height>31</height>';
$_rss_content.= '</image>';

for ($i = 0; $i < count($news); $i++)
{
    $post_text = $news[$i]['post_text'];
    $post_text = str_replace("\n", "<br />", $post_text);
    $post_text = str_replace($takeouts, '', $post_text);
	
	$_rss_content.= '<item>';
	$_rss_content.= '<title>';
	$_rss_content.= $news[$i]['topic_title'];
	$_rss_content.= '</title>';
	$_rss_content.= '<link>http://www.theghz.com/news/index.php?article=';
	$_rss_content.= $news[$i]['topic_id'];
	$_rss_content.= '</link>';
	$_rss_content.= '<author>';
	$_rss_content.= $news[$i]['username'];
	$_rss_content.= '</author>';
	$_rss_content.= '<description>Posted by ';
	$_rss_content.= $news[$i]['username'];
	$_rss_content.= '.&lt;br /&gt;';
	$_rss_content.= 'Posted ';
	$_rss_content.= $news[$i]['date'];
	$_rss_content.= $news[$i]['time'];
	$_rss_content.= 'EST&lt;br /&gt;&lt;br /&gt;';
	$_rss_content.= strtr($post_text, $specials);
	$_rss_content.= '</description>';
	$_rss_content.= '<pubDate>';
	$_rss_content.= $news[$i]['date'];
	$_rss_content.= $news[$i]['time'];
	$_rss_content.= 'EST';
	$_rss_content.= '</pubDate>';
	$_rss_content.= '<guid>';
	$_rss_content.= 'http://www.theghz.com/forum/viewtopic.php?t=';
	$_rss_content.= $news[$i]['topic_id'];
	$_rss_content.= '</guid>';
	$_rss_content.= '</item>';
}

$_rss_content.= '</channel>';
$_rss_content.= '</rss>';

$_handler = fopen($_feed_file, 'w') or die("Can't open feed file.");
fwrite($_handler, $_rss_content);
fclose($_handler);
?>
<html>
<head>
</head>
<body>
<p>Newsboard updated successfully.<br />
- <a href="<?php echo $_feed_file; ?>">Check feed file</a><br />
- <a href="./">Go to front page</a></p>
</body>
</html>